
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_CLIENT_NEW_OIDS_STORE_H
#define PG_CLIENT_NEW_OIDS_STORE_H

#include "xstd/Ring.h"

class NidPack {
	public:
		NidPack(int aBeg = 0, int anEnd = 0): beg(aBeg), end(anEnd) {}

		bool exhausted() const { return beg >= end; }

		int next() { return beg++; }

	public:
		int beg;
		int end;
};

class NidsStore {
	public:
		NidsStore();

		void configure(int prefetchLmt, int reqLmt);
		void reset();

		bool empty() const { return !theCount; }

		int shortage() const;

		int next();
		int last() const { return theLastNid; }

		void add(int start, int count);
		void noteNoNids(); // client ran out of new oids

	protected:
		bool wasFull() const;

	protected:
		static int TheFillingStoreCount; // stores in "filling" state

		static int ThePrefetchLmt; // store no more than that
		static int TheReqLmt;      // request no more than that at a time

	protected:
		Ring<NidPack> theNids;
		int theCount;      // total nids stored


		int theLastNid;    // cache
		int theMaxFillLvl; // to check whether we ever had "enough" nids
};

#endif
