
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_BOOL_SYMBOL_H
#define PGL_BOOL_SYMBOL_H

#include "PglExprSym.h"

class BoolSym: public ExpressionSym {
	public:
		BoolSym(bool aVal);

		bool val() const { return theVal; }
		void val(bool v) { theVal = v; }

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		virtual ExpressionSym *unOper(const String &op) const;
		virtual ExpressionSym *bnOper(const String &op, const SynSym &exp) const;

		virtual ostream &print(ostream &os, const String &pfx = 0) const;

	protected:
		bool theVal;
};

#endif
