
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef POLYGRAPH_PGL_CONTEXT_H
#define POLYGRAPH_PGL_CONTEXT_H

#include "SynSymTbl.h"

// holds current parsing context
// contexts can be nested
// contexts may be "named" (equivalent to "using" clause in Pascal)
class PglCtx: public SynSymTbl {
	public:
		static PglCtx *RootCtx() { return TheRootCtx; }

	public:
		PglCtx(const String &aName, PglCtx *aParent = 0);
		virtual ~PglCtx();

		PglCtx *parent() { return theParent; }
		const String &name() const { return theName; }
		int nestDepth() const;

		virtual SynSymTblItem **valp(const String &key);

		virtual void report(ostream &os, const String &) const;

	protected:
		// recusrsive search
		SynSymTblItem **valpR(const String &key);
		// search for a.b
		SynSymTblItem **memberp(const String &name);

		virtual void noteAdd(int idx);
		virtual void noteDel(int idx);

	protected:
		static PglCtx *TheRootCtx; // root context

	protected:
		String theName;
		PglCtx *theParent; // null for root context
};

#endif
