
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_DISTRIBUTION_SYMBOL_H
#define PGL_DISTRIBUTION_SYMBOL_H

#include "PglExprSym.h"

class String;
class RndDistr;
class QualifSym;

// a distribution with an optional qualifier

class DistrSym: public ExpressionSym {
	public:
		DistrSym(const String &aType, RndDistr *aVal);
		virtual ~DistrSym();

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		RndDistr *val() const { return theVal; }

		void qualifier(const QualifSym *aQual, const String &anOp);
		QualifSym *qualifier() const { return theQual; }
		const String &qfOp() const { return theQfOp; }

		virtual ostream &print(ostream &os, const String &pfx = 0) const;

	protected:
		mutable RndDistr *theVal;
		QualifSym *theQual; // qualifier
		String theQfOp;     // qualifier operator
};

#endif
