
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "polygraph.h"

#include "Socket.h"
#include "LogComment.h"
#include "ErrorMgr.h"
#include "PortMgr.h"

LevelStat PortMgr::TheBoundLvl;


PortMgr::PortMgr(const NetAddr &anAddr): theAddr(anAddr) {
}

int PortMgr::bind(Socket &s) {
	const int port = allocPort(s);
	if (port >= 0) // success
		++TheBoundLvl;
	else
	if (ReportError(errno))
		Comment << "failed to bind to " << theAddr << endc;

	return port;
}

void PortMgr::release(int port, bool good) {
	Assert(port >= 0);
	freePort(port, good);
	--TheBoundLvl;
}
