
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_SERVER_TRANSACTION_H
#define PG_SERVER_TRANSACTION_H

#include "xstd/AlarmClock.h"
#include "base/ObjTimes.h"
#include "runtime/Xaction.h"
#include "runtime/httpHdrs.h"

class Server;
class CltGroupRep;
class ContentCfg;
class BodyIter;
class WrBuf;

class SrvXact: public Xaction, public AlarmUser {
	public:
		SrvXact() { SrvXact::reset(); }

		virtual void reset();

		void exec(Server *anOwner, Connection *aConn, Time delay);

		virtual void noteReadReady(int fd);
		virtual void noteWriteReady(int fd);
		virtual void wakeUp(const Alarm &a);

	protected:
		virtual Agent *owner();

		void makeRep(WrBuf &buf);
		void makeRep200(ostream &os);
		void makeRep304(ostream &os);
		void putStdFields(ostream &os) const;

		Size calcRepSize() const;
		bool calcCachability() const;

		void doStart();
		void noteDataReady();
		void gotHeader();

		virtual void finish(int errNo);
		virtual void logStats(OLog &ol) const;

	protected:
		Server *theOwner;
		CltGroupRep *theCltGroupRep;
		ContentCfg *theContentCfg;
		BodyIter *theBodyIter;
		ReqHdr theReqHdr;

		ObjTimes theTimes;    // mod, lmt, and such
		Size theRepHdrSize;

		Size theProducedSize;

	private:
		int theSeed;          // oid-based seed used for r.n.g
};

#endif

